namespace WebApi.Controllers;

[ApiController]
[Route("api/[controller]/[action]")]
public class NotificationController(INotificationService notificationService) : ControllerBase
{
    [HttpGet()]
    public async Task<BaseResponse<string>> GetVapidPublicKey()
    {
        try
        {
            var key = await notificationService.GetVapidPublicKeyAsync();
            return key.Ok<string>();
        }
        catch (Exception ex)
        {
            return ex.Message.Fail<string>();
        }
    }

    public async Task<BaseResponse> Subscribe([FromBody] PushSubscription subscription)
    {
        try
        {
            await notificationService.SubscribeAsync(subscription);
            return BaseResponse.Done();
        }
        catch (Exception ex)
        {
            return ex.Message.Fail();
        }
    }
    
    public async Task<BaseResponse> TestNotification([FromQuery] string message)
    {
        try
        {
            await notificationService.SendNotificationAsync(message);
            return BaseResponse.Done();
        }
        catch (Exception ex)
        {
            return ex.Message.Fail();
        }
    }
}
